#define OS_MAIN
#include <jacos.h>
#include "..\prim_io.h"

OST_TASK_T task1;
OST_TASK   task2;
OST_TASK   task3;

OST_SEMAPHORE event1;

unsigned char counter;

__task void T_1(void)
{
  OST_ERR_MSG y;
  while (1) {
    counter++;
    OS_Delay(10);
    OS_Post_BSemR(&event1, &y);
    if (y == OS_NOERR) counter++;
  }
}

__task void T_2(void)
{
  while (1) {
    counter++;
    OS_Wait_Sem(&event1);
    counter++;
  }
}

__task void T_3(void)
{
  while (1) {
    counter++;
    OS_Cooperate();
    counter++;
  }
}

void main(void)
{
  OS_Init();
  OS_Task_Create(T_1, &task1);
  OS_Task_Create(T_2, &task2);
  OS_Task_Create(T_3, &task3);

  OS_Sem_Create(&event1, 0);

  #include "..\prim_tmr.c"

  while (1) {
    OS_Scheduler();
  }
}

//__interrupt void intr(void)
#include "..\prim_isr.c"
{
  /*if ( OS_Is_Timer()){}*/
  OS_Timer_Tick_Set();
  OS_Timer();
}


