#define OS_MAIN
#include <jacos.h>
#include "..\prim_io.h"

OST_TASK_T task1;
OST_TASK_T task2;
OST_TASK_T task3;

OST_MESSAGE event1;

unsigned char counter;
unsigned char even;
unsigned char odd;

__task void T_1(void)
{
  unsigned char * tx;
  OST_ERR_MSG y;
  while (1) {
    counter++;
    OS_Delay(20);
    if (counter & 1) {
      tx = &odd;
    } else {
      tx = &even;
    }
    OS_Post_MsgR(&event1, tx, &y);
    if (y == OS_ERROR) {
      counter = 0;
    }
  }
}

OST_MSG_P rx;

__task void T_2(void)
{
  while (1) {
    counter++;
    OS_Wait_MsgT(&event1, &rx, 15);
    if ( !OS_Timeout() ) {
      (*(unsigned char *)rx)++;
    }
  }
}

__task void T_3(void)
{
  while (1) {
    counter++;
    OS_Delay(2);
    counter++;
  }
}

void main(void)
{
  OS_Init();
  OS_Task_Create(T_1, &task1, 1);
  OS_Task_Create(T_2, &task2, 1);
  OS_Task_Create(T_3, &task3, 0);

  OS_Msg_Create(&event1, 0);

  #include "..\prim_tmr.c"

  while (1) {
    OS_Scheduler();
  }
}

void OS_Idle(void)
{
  counter--;
}

//__interrupt void intr(void)
#include "..\prim_isr.c"
{
  /*if ( OS_Is_Timer()){}*/
  OS_Timer_Tick_Set();
  OS_Timer();
}



