
#if ( defined(_PIC_) || defined(_PIC18_) ) && defined(_HT_)
                                        // PIC12, PIC16, PIC18 Hi-Tech
  #ifdef OS_USE_EV_EVRW
    #pragma interrupt_level 0
  #endif
  interrupt void intr(void)

#elif defined(_PIC18_) && defined(_IAR_)// PIC18 IAR
  #pragma vector = 0x08
  __interrupt void intr(void)

#elif defined(_PIC18_) && defined(_MC_) // PIC18 MC
  void high_isr(void);
  #pragma code high_vector = 0x08
  void interrupt_at_high_vector(void) { _asm GOTO high_isr _endasm }
  #pragma code
  #pragma interrupt high_isr
  void high_isr(void)

#elif defined(_AVR_) && defined(_IAR_)  // AVR IAR
  #ifdef TIMER0_OVF_vect
    #pragma vector=TIMER0_OVF_vect
  #else
    #pragma vector=TIMER0_OVF0_vect
  #endif
  __interrupt void intr(void)

#elif defined(_AVR_) && defined(_GCC_)  // AVR WINAVR
  SIGNAL(SIG_OVERFLOW0)
  //INTERRUPT(SIG_OVERFLOW0)

#elif defined(_MSP_)                    // MSP430 IAR
  #pragma vector=TIMERA1_VECTOR         // io430x11x.h
  __interrupt void intr(void)

#elif defined(_ARM_) && defined(_IAR_)  // ARM IAR
  #pragma vector=0x18
  __arm __irq  void intr(void);
  #pragma required=intr
  __arm __irq  void intr(void)

#elif defined(_51_) && defined(_KEIL_)  // 8x51 Keil
  void intr(void) interrupt 1 using 2

#elif defined(_DSPIC_) && defined(_MC_) // dsPIC MC
  void _ISR _T1Interrupt(void)          //_ISRFAST

#elif defined(_DSPIC_) && defined(_IAR_)// dsPIC IAR
  #pragma vector = 0x1A
  __interrupt void intr(void)

#elif defined(_DSPIC_) && defined(_HT_) // dsPIC HT
  interrupt void intr(void) @ T1_VCTR

#endif

